/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.plugins.entitybean.swing;

import middlegen.Column;
import middlegen.plugins.entitybean.*;
import middlegen.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * This panel renders and modifies columns
 *
 * @author Aslak Hellesy
 * @created 3. oktober 2001
 * @version
 */
public class JEntity20ColumnSettingsPanel extends JEntity11ColumnSettingsPanel {

   /**
    * @todo-javadoc Describe the field
    */
   protected JComboBox _porteeVOCombo;

   /**
    * @todo-javadoc Describe the field
    */
   protected JLabel _porteeVOLabel;

   /**
    * @todo-javadoc Describe the field
    */
   protected JLabel _ctorLabel;
   /**
    * @todo-javadoc Describe the column
    */
   private BooleanNodeCheckBox _localSetterCheckBox;

   /**
    * @todo-javadoc Describe the column
    */
   private BooleanNodeCheckBox _localGetterCheckBox;

   // checkbox bc
   /**
    * @todo-javadoc Describe the field
    */
   private BooleanNodeCheckBox _creatableCheckBoxColumn;

   /**
    * @todo-javadoc Describe the field
    */
   private BooleanNodeCheckBox _updatableCheckBoxColumn;

   /**
    * @todo-javadoc Describe the field
    */
   private BooleanNodeCheckBox _ctorCheckBoxColumn;

   /**
    * @todo-javadoc Describe the field
    */
   private final ActionListener _porteeVOListener =
      new ActionListener() {
         public void actionPerformed(ActionEvent event) {
            update();
         }


         private void update() {
            for (int i = 0; i < _currentColumns.length; i++) {
               //			System.out.println(" click on " +
               // _currentColumns[i].getVariableName());
               String type = (String)_porteeVOCombo.getSelectedItem();
               _log.debug("portee setter dans VO = " + type);
               Entity20Column col = (Entity20Column)_currentColumns[0];
               col.setPorteeVO(type);

            }
         }
      };

   /**
    * @todo-javadoc Describe the field
    */
   private static org.apache.log4j.Category _log = org.apache.log4j.Category.getInstance(JEntity20ColumnSettingsPanel.class.getName());


   //	private BooleanNodeCheckBox _voPublicCheckBoxColumn;
   //	private BooleanNodeCheckBox _voProtectedCheckBoxColumn;
   //	private BooleanNodeCheckBox _voPrivateCheckBoxColumn;
   //	private BooleanNodeCheckBox _voNotConcernedCheckBoxColumn;

   /**
    * Describe what the JColumnSettingsPanel constructor does
    *
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for constructor
    */
   public JEntity20ColumnSettingsPanel() {

      super();

      _log.debug("ctor JEntity20ColumnSettingsPanel");
      _porteeVOCombo.addActionListener(_porteeVOListener);

   }


   /**
    * Sets the Column attribute of the JColumnSettingsPanel object
    *
    * @todo fixme
    * @param columns The new Columns value
    */
   public void setColumns(final Column[] columns) {
      super.setColumns(columns);
      //		System.out.println(" set cols : nb ->" + _currentColumns.length);
      if (_currentColumns.length == 1) {

         _localSetterCheckBox.setBooleanNode(((Entity20Column)_currentColumns[0])
               .getLocalSet());

         _localGetterCheckBox.setBooleanNode(((Entity20Column)_currentColumns[0])
               .getLocalGet());

         _creatableCheckBoxColumn.setBooleanNode(((Entity20Column)_currentColumns[0])
               .getCreatable());

         _updatableCheckBoxColumn.setBooleanNode(((Entity20Column)_currentColumns[0])
               .getUpdatable());

         //			_voPublicCheckBoxColumn.setBooleanNode(
         //					((Entity20Column) _currentColumns[0]).getVoPublic());

         DefaultComboBoxModel model = new DefaultComboBoxModel();
         model.addElement("public");
         model.addElement("private");
         model.addElement("protected");

         _porteeVOCombo.setModel(model);
         Entity20Column col = (Entity20Column)_currentColumns[0];
         if (col.getPorteeVO() != null) {
            _porteeVOCombo.setSelectedItem(col.getPorteeVO());
         }

         _ctorCheckBoxColumn.setBooleanNode(((Entity20Column)_currentColumns[0])
               .getCtor());

      }
   }


   /**
    * Describe what the method does
    *
    * @todo-javadoc Write javadocs for method
    */
   protected void initComponents() {

      super.initComponents();

      _localSetterCheckBox = new BooleanNodeCheckBox("Local", null);
      _localGetterCheckBox = new BooleanNodeCheckBox("Local", null);
      _creatableCheckBoxColumn = new BooleanNodeCheckBox("Not Creatable",
            null);
      _updatableCheckBoxColumn = new BooleanNodeCheckBox("Not Updatable",
            null);

      _porteeVOLabel = new JLabel("Porte (setter) dans Value Object");
      _porteeVOCombo = new JComboBox();

      _ctorLabel = new JLabel("Value Object");
      _ctorCheckBoxColumn = new BooleanNodeCheckBox(
            "appartient au CTOR mimimal", null);

   }


   /**
    * Describe the method
    *
    * @todo-javadoc Describe the method
    */
   protected void addComponents() {

      GridLayout gridLayout = new GridLayout(0, 2, 4, 8);
      setLayout(gridLayout);
      add(_columnNameLabel);
      add(_columnNameField);
      add(_columnTypeLabel);
      add(_columnTypeCombo);
      add(_setterLabel);

      // new
      JPanel setterPanel = new JPanel();
      setterPanel.add(_localSetterCheckBox);
      setterPanel.add(_remoteSetterCheckBox);
      add(setterPanel);

      JPanel getterPanel = new JPanel();

      // new
      add(_getterLabel);
      getterPanel.add(_localGetterCheckBox);
      getterPanel.add(_remoteGetterCheckBox);
      add(getterPanel);

      //
      //		JPanel createPanel = new JPanel();
      //		createPanel.add(_creatableCheckBoxColumn);
      //		createPanel.add(_updatableCheckBoxColumn);
      //		add(createPanel);

      //
      add(_porteeVOLabel);
      JPanel voPanel = new JPanel();
      voPanel.add(_porteeVOCombo);
      add(voPanel);

      add(_ctorLabel);
      JPanel voCTOR = new JPanel();
      voCTOR.add(_ctorCheckBoxColumn);
      add(voCTOR);

   }
}
