/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.swing;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.*;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import middlegen.*;

/**
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy </a>
 * @created 3. oktober 2001
 * @version $Id: JMiddlegenFrame.java,v 1.1 2004/08/20 06:53:31 manu Exp $
 */
public class JMiddlegenFrame extends JFrame {

   // menu
   /**
    * @todo-javadoc Describe the field
    */
   JMenuBar jMenuBar1 = new JMenuBar();

   //
   /**
    * @todo-javadoc Describe the field
    */
   JMenu jMenuFile = new JMenu();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuFileExit = new JMenuItem();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuGenerer = new JMenuItem();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuTables = new JMenuItem();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuRelations = new JMenuItem();

   /**
    * @todo-javadoc Describe the field
    */
   JMenu jMenuView = new JMenu();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuViewBeautify = new JMenuItem();

   /**
    * @todo-javadoc Describe the field
    */
   JLabel statusBar = new JLabel();

   /**
    * @todo-javadoc Describe the field
    */
   JMenu jMenuHelp = new JMenu();

   /**
    * @todo-javadoc Describe the field
    */
   JMenuItem jMenuHelpAbout = new JMenuItem();
   /**
    * @todo-javadoc Describe the column
    */
   private final JDatabasePanel _databasePanel;

   /**
    * @todo-javadoc Describe the field
    */
   private final JSplitPane _split;

   /**
    * @todo-javadoc Describe the column
    */
   private final Middlegen _middlegen;

   /**
    * This action generates sources
    *
    * @todo refactor the meat to a separate method
    */
   //	private Action _generateAction = new AbstractAction("Generate") {
   //		public void actionPerformed(ActionEvent evt) {
   //			try {
   //				setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
   //				try {
   //					_middlegen.writeSource();
   //				} catch (MiddlegenException e) {
   //					error(e);
   //				}
   //			} finally {
   //				setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
   //			}
   //		}
   //	};
   //
   //	private Action _ListTables = new AbstractAction("List Tables") {
   //		public void actionPerformed(ActionEvent evt) {
   //				// try {
   //	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
   //			// try {
   //			// // _middlegen.writeSource();
   //			// } catch (MiddlegenException e) {
   //			// error(e);
   //			// }
   //			// } finally {
   //			setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
   //			// }
   //		}
   //	};
   /**
    * Get static reference to Log4J Logger
    */
   private static org.apache.log4j.Category _log = org.apache.log4j.Category.getInstance(JMiddlegenFrame.class.getName());


   /**
    * The main program for the MiddlemanFrame class
    *
    * @todo describe the command line arguments
    * @param middlegen Describe what the parameter does
    * @param title Describe what the parameter does
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for method parameter
    */
   public JMiddlegenFrame(Middlegen middlegen, String title) {

      super(title);

      _middlegen = middlegen;

      setKuststoffLF();

      // make panel with label header and tabs in center.
      JLabel header = new JLabel("", JLabel.CENTER);
      JSettingsTabPane settingsTabs = new JSettingsTabPane(middlegen.getPlugins());

      JPanel headerTabs = new JPanel(new BorderLayout());

      headerTabs.add(header, BorderLayout.NORTH);
      // headerTabs.add(settingsTabs, BorderLayout.CENTER);
      JToolBar pluginToolBar = new JToolBar();
      pluginToolBar.add(settingsTabs);
      headerTabs.add(pluginToolBar, BorderLayout.CENTER);

      _databasePanel = new JDatabasePanel(settingsTabs, header);

      JScrollPane scroll = new JScrollPane(_databasePanel);
      _split = new JSplitPane(JSplitPane.VERTICAL_SPLIT, scroll, headerTabs);
      _split.setDividerLocation(0.5);
      getContentPane().add(_split, BorderLayout.CENTER);

      //		JToolBar toolBar = new JToolBar();
      //		toolBar.add(_generateAction);
      //		toolBar.addSeparator();
      //		toolBar.add(_ListTables);
      //		toolBar.addSeparator();
      //		toolBar.add(
      //			new JLabel("CTRL-Click relations to modify their cardinality"));
      //		toolBar.addSeparator();
      //		toolBar.add(
      //			new JLabel("SHIFT-Click relations to modify their directionality"));

      // show menu's

      // menu File
      jMenuFile.setText("Fichier");
      jMenuFileExit.setText("Quitter");
      jMenuFileExit.addActionListener(new JMiddlegenFrame_jMenuFileExit_ActionAdapter(
            this));

      jMenuGenerer.setText("Gnrer");
      jMenuGenerer.addActionListener(new JMiddlegenFrame_jMenuGenerer_ActionAdapter(
            this));

      jMenuTables.setText("Tables ...");
      jMenuTables.addActionListener(new JMiddlegenFrame_jMenuTables_ActionAdapter(
            this));

      jMenuRelations.setText("Relations ...");
      jMenuRelations.addActionListener(new JMiddlegenFrame_jMenuRelations_ActionAdapter(
            this));

      jMenuFile.add(jMenuGenerer);
      jMenuFile.add(jMenuTables);
      jMenuFile.add(jMenuRelations);
      jMenuFile.addSeparator();
      jMenuFile.add(jMenuFileExit);

      jMenuHelp.setText("Aide");
      jMenuHelpAbout.setText("A propos");
      jMenuHelpAbout.addActionListener(new JMiddlegenFrame_jMenuHelp_ActionAdapter(
            this));

      jMenuHelp.add(jMenuHelpAbout);
      jMenuBar1.add(jMenuFile);
      jMenuBar1.add(jMenuView);
      jMenuBar1.add(jMenuHelp);

      this.setJMenuBar(jMenuBar1);

      // Menu View
      jMenuView.setText("Vue");
      jMenuViewBeautify.setText("Organiser");
      jMenuViewBeautify.addActionListener(new JMiddlegenFrame_jMenuViewBeautify_ActionAdapter(
            this));

      jMenuView.add(jMenuViewBeautify);

      //		getContentPane().add(toolBar, BorderLayout.NORTH);
      getContentPane().add(statusBar, BorderLayout.SOUTH);

      ImageIcon icon = new ImageIcon(getClass().getResource("m.gif"));
      setIconImage(icon.getImage());

      // dispose Frame on closing, so VM will exit when Ant Task has finished
      setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

      //

      // I have a dodgy feeling that a Mac would try to exit the VM when the
      // window closes. Try to uncomment this line on a Mac.
      // System.setSecurityManager(new NoExitSecurityManager());

      addWindowListener(
         new WindowAdapter() {

            public void windowClosing(WindowEvent evt) {
               // Tell the halted Ant task to resume.
               synchronized (MiddlegenTask.getLock()) {
                  // Update positions of tables
                  _databasePanel.setPrefs();
                  // Let the ant task to continue
                  MiddlegenTask.getLock().notify();
               }
            }
         });

   }


   /**
    * Sets the Splitter attribute of the JMiddlegenFrame object
    */
   public void setSplitter() {
      int fheight = this.getHeight();
      int sheight = Toolkit.getDefaultToolkit().getScreenSize().height;
      if (fheight >= sheight) {
         _split.setDividerLocation(sheight - 480);
      }
      _split.setOneTouchExpandable(true);
   }


   /**
    * Sets the Visible attribute of the JMiddlegenFrame object
    *
    * @param flag The new Visible value
    */
   public void setVisible(boolean flag) {
      super.setVisible(flag);
      _databasePanel.reset(_middlegen);
      pack();
   }


   //Opration Fichier | Quitter effectue
   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuFileExit_actionPerformed(ActionEvent e) {
      WindowEvent ev = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
      dispatchEvent(ev);
      this.dispose();
   }


   //Opration Fichier | Quitter effectue

   /**
    * Describe what the method does
    *
    * @todo-javadoc Write javadocs for method
    */
   public void processStatusBar() {
      this.processWindowEvent(new WindowEvent(this,
            WindowEvent.WINDOW_STATE_CHANGED));
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuGenerer_actionPerformed(ActionEvent e) {
      try {
         setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         try {
            _middlegen.writeSource(this, this.statusBar);

         } catch (MiddlegenException ex) {
            error(ex);
         }
      } finally {
         setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      }
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuTables_actionPerformed(ActionEvent e) {

      JMiddlegenFrameTables jtables = new JMiddlegenFrameTables(
            this._middlegen);

      // mmoriser positions

      _databasePanel.setPrefs();

      jtables.setModal(true);
      jtables.setSize(300, 300);
      jtables.setLocation(300, 300);
      jtables.setTitle("Select tables ...");

      jtables.setVisible(true);

      _databasePanel.reset(_middlegen);

      //		this.setVisible(true);

   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuHelp_actionPerformed(ActionEvent e) {

   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuRelations_actionPerformed(ActionEvent e) {

      JMiddlegenFrameRelations jrelations = new JMiddlegenFrameRelations(
            this._middlegen);

      // mmoriser positions

      _databasePanel.setPrefs();

      jrelations.setModal(true);
      jrelations.setSize(300, 300);
      jrelations.setLocation(300, 300);
      jrelations.setTitle("Select relations ...");

      jrelations.setVisible(true);

      _databasePanel.reset(_middlegen);

      //		this.setVisible(true);

   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void jMenuViewBeautify_actionPerformed(ActionEvent e) {

      // balayer toutes les tables les placer dans l'cran

      _log.debug("\n\n dans beauti ANALYSE AVEC RELATION");

      Iterator it = _databasePanel.get_tablePanels().iterator();
      _log.debug("dans beauti it = null" + (it == null));

      int x = 10;
      int y = 10;
      int h = 0;
      int w = 0;
      int xMax = 0;
      Dimension dim = null;
      while (it.hasNext()) {

         JTablePanel tablePanel = (JTablePanel)it.next();
         DbTable table = tablePanel.getTable();
         _log.debug("Analyze table = " + table.getName());
         if (!hasRelationEnabled(table.getRelationshipRoles())) {
            continue;
         }

         _log.debug("dans beauti table = " + table.getName()
                + " position [x,y] : [" + x + "," + y + "]"
                + " nbre de noeuds = "
                + table.getRelationshipRoles().size());

         table.setPosition(x, y);
         dim = tablePanel.getSize();

         if (dim.height > h) {
            h = dim.height;
         }

         if (dim.width > w) {
            w = dim.width;
         }

         x += dim.width + 10;
         xMax = x > xMax ? x : xMax;

         if (x > 1000) {
            x = 10;
            y += h + 10;
            h = 0;
         }

      }

      it = _databasePanel.get_tablePanels().iterator();
      _log.debug("dans beauti it = null" + (it == null));

      x = xMax + 10;
      y = 10;
      h = 0;
      w = 0;

      // sans relation
      _log.debug("\n\n dans beauti ANALYSE SANS RELATION" + (it == null));
      int wmax = 0;
      int hMax = 0;
      while (it.hasNext()) {

         JTablePanel tablePanel = (JTablePanel)it.next();
         DbTable table = tablePanel.getTable();
         if (hasRelationEnabled(table.getRelationshipRoles())) {
            continue;
         }

         dim = tablePanel.getSize();
         if (dim.height > hMax) {
            hMax = dim.height;
         }

         if (dim.width > wmax) {
            wmax = dim.width;
         }

      }
      _log.debug(" hMax : " + hMax + " wmax : " + wmax);
      it = _databasePanel.get_tablePanels().iterator();

      while (it.hasNext()) {

         JTablePanel tablePanel = (JTablePanel)it.next();
         DbTable table = tablePanel.getTable();
         if (hasRelationEnabled(table.getRelationshipRoles())) {
            continue;
         }

         _log.debug("dans beauti table = " + table.getName()
                + " position [x,y] : [" + x + "," + y + "]"
                + " nbre de noeuds = "
                + table.getRelationshipRoles().size());

         table.setPosition(x, y);

         x += wmax + 10;

         if (x > 1500) {
            x = xMax + 10;
            y += hMax + 10;
            h = 0;
         }
      }

      _databasePanel.reset(this._middlegen);

   }


   /**
    * Sets the cool kunststoff L&F.
    */
   private void setKuststoffLF() {
      /*
       *  try { com.incors.plaf.kunststoff.KunststoffLookAndFeel kunststoffLnF =
       *  new com.incors.plaf.kunststoff.KunststoffLookAndFeel();
       *  kunststoffLnF.setCurrentTheme(new
       *  com.incors.plaf.kunststoff.KunststoffTheme());
       *  UIManager.setLookAndFeel(kunststoffLnF); / this line needs to be
       *  implemented in order to make JWS work properly
       *  UIManager.getLookAndFeelDefaults().put("ClassLoader",
       *  getClass().getClassLoader()); } catch (Throwable ignore) { }
       */
   }


   /**
    * Describe what the method does
    *
    * @param rels Describe what the parameter does
    * @return Describe the return value
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for return value
    */
   private boolean hasRelationEnabled(Collection rels) {

      if (rels == null) {
         _log.debug(" rels de roles = null");
         return false;
      }

      Iterator col = rels.iterator();
      while (col.hasNext()) {
         RelationshipRole role = (RelationshipRole)col.next();
         _log.debug("analyze role " + role.getName() + " "
                + role.isEnabled() + " "
                + role.getRelation().getLeftRole().isEnabled() + " "
                + role.getRelation().getRightRole().isEnabled());
      }
      col = rels.iterator();
      while (col.hasNext()) {
         RelationshipRole role = (RelationshipRole)col.next();
         if (role.getRelation().getLeftRole().isEnabled()) {
            return true;
         }
         if (role.getRelation().getRightRole().isEnabled()) {
            return true;
         }
      }
      return false;
   }


   /**
    * Describe what the method does
    *
    * @param t Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   private void error(Throwable t) {
      t.printStackTrace();
      JOptionPane.showMessageDialog(this, t);
   }


   /**
    * This security manager will cause an ExitException to be thrown whenever
    * System.exit is called instead of terminating the VM.
    *
    * @author Aslak Hellesy
    * @created 2. desember 2002
    */
   public static class NoExitSecurityManager extends SecurityManager {
      /**
       * Throws an ExitException instead of terminating the VM.
       *
       * @param status Describe what the parameter does
       * @todo-javadoc Write javadocs for method parameter
       */
      public void checkExit(int status) {
         throw new ExitException(status);
      }


      /**
       * Allows anything.
       *
       * @param p Describe what the parameter does
       * @todo-javadoc Write javadocs for method parameter
       */
      public void checkPermission(java.security.Permission p) {
      }
   }


   /**
    * Describe what this class does
    *
    * @author Aslak Hellesy
    * @created 2. desember 2002
    * @todo-javadoc Write javadocs
    */
   public static class ExitException extends RuntimeException {
      /**
       * @todo-javadoc Describe the field
       */
      private int _status;


      /**
       * Describe what the ExitException constructor does
       *
       * @param status Describe what the parameter does
       * @todo-javadoc Write javadocs for constructor
       * @todo-javadoc Write javadocs for method parameter
       */
      public ExitException(int status) {
         _status = status;
      }


      /**
       * Gets the Status attribute of the ExitException object
       *
       * @return The Status value
       */
      public int getStatus() {
         return _status;
      }
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuFileExit_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuFileExit_ActionAdapter constructor
    * does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuFileExit_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuFileExit_actionPerformed(e);
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuGenerer_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuGenerer_ActionAdapter constructor
    * does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuGenerer_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuGenerer_actionPerformed(e);
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuTables_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuTables_ActionAdapter constructor
    * does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuTables_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuTables_actionPerformed(e);
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuRelations_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuRelations_ActionAdapter constructor
    * does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuRelations_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuRelations_actionPerformed(e);
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuViewBeautify_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuViewBeautify_ActionAdapter
    * constructor does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuViewBeautify_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuViewBeautify_actionPerformed(e);
   }
}

/**
 * Describe what this class does
 *
 * @author Cnedi
 * @created 20 aot 2004
 * @todo-javadoc Write javadocs
 */
class JMiddlegenFrame_jMenuHelp_ActionAdapter implements ActionListener {


   /**
    * @todo-javadoc Describe the field
    */
   JMiddlegenFrame adaptee;


   /**
    * Describe what the JMiddlegenFrame_jMenuHelp_ActionAdapter constructor does
    *
    * @param adaptee Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   JMiddlegenFrame_jMenuHelp_ActionAdapter(JMiddlegenFrame adaptee) {
      this.adaptee = adaptee;
   }


   /**
    * Describe what the method does
    *
    * @param e Describe what the parameter does
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    */
   public void actionPerformed(ActionEvent e) {
      adaptee.jMenuHelp_actionPerformed(e);
   }
}
